/*
p to p
j2ee -verbose
j2eeadmin -addJmsDestination MyQueue queue
java HelloWorldJmsProducer
*/

import javax.naming.*;
import javax.jms.*;

public class HelloWorldJmsProducer {
  public final static String JMS_FACTORY="QueueConnectionFactory";
  public final static String QUEUE="MyQueue";

  public static void main(String args[]) {
    try {
      QueueConnectionFactory queueConnectionFactory;
      QueueConnection queueConnection;
      QueueSession queueSession;
      QueueSender queueSender;
      Queue queue;
      TextMessage msg;

      InitialContext ctx = new InitialContext();

      queueConnectionFactory  = (QueueConnectionFactory)ctx.lookup(JMS_FACTORY);
      queue = (Queue) ctx.lookup(QUEUE);

      queueConnection = queueConnectionFactory.createQueueConnection();

      queueSession = queueConnection.createQueueSession(false,Session.AUTO_ACKNOWLEDGE);

      queueSender   = queueSession.createSender(queue);
      msg     = queueSession.createTextMessage();
      msg.setText("Hello World");
      queueConnection.start();
      queueSender  .send(msg);
      queueSender.close();
      queueSession.close();
      queueConnection.close();
    } catch (Exception e) {
      e.printStackTrace();
    }
  }
}
